<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelContractType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelContractType extends AbstractStructArrayBase
{
    /**
     * The ContractType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelContractType[]
     */
    public $ContractType;
    /**
     * Constructor method for ArrayOfJP_HotelContractType
     * @uses ArrayOfJP_HotelContractType::setContractType()
     * @param \StructType\JP_HotelContractType[] $contractType
     */
    public function __construct(array $contractType = array())
    {
        $this
            ->setContractType($contractType);
    }
    /**
     * Get ContractType value
     * @return \StructType\JP_HotelContractType[]|null
     */
    public function getContractType()
    {
        return $this->ContractType;
    }
    /**
     * This method is responsible for validating the values passed to the setContractType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContractType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContractTypeForArrayConstraintsFromSetContractType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelContractTypeContractTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelContractTypeContractTypeItem instanceof \StructType\JP_HotelContractType) {
                $invalidValues[] = is_object($arrayOfJP_HotelContractTypeContractTypeItem) ? get_class($arrayOfJP_HotelContractTypeContractTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelContractTypeContractTypeItem), var_export($arrayOfJP_HotelContractTypeContractTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ContractType property can only contain items of type \StructType\JP_HotelContractType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ContractType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelContractType[] $contractType
     * @return \ArrayType\ArrayOfJP_HotelContractType
     */
    public function setContractType(array $contractType = array())
    {
        // validation for constraint: array
        if ('' !== ($contractTypeArrayErrorMessage = self::validateContractTypeForArrayConstraintsFromSetContractType($contractType))) {
            throw new \InvalidArgumentException($contractTypeArrayErrorMessage, __LINE__);
        }
        $this->ContractType = $contractType;
        return $this;
    }
    /**
     * Add item to ContractType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelContractType $item
     * @return \ArrayType\ArrayOfJP_HotelContractType
     */
    public function addToContractType(\StructType\JP_HotelContractType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelContractType) {
            throw new \InvalidArgumentException(sprintf('The ContractType property can only contain items of type \StructType\JP_HotelContractType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ContractType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelContractType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelContractType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelContractType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelContractType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelContractType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ContractType
     */
    public function getAttributeName()
    {
        return 'ContractType';
    }
}
